from pylab import *

#simlss data
k,pk,pkno=loadtxt("simlss_dr9_z0.5.txt",skiprows=2,unpack=True,usecols=(0,1,2))

#d'apres HE
h=0.7
Om0=0.27
Ob0=0.05
s=44.5*log(9.83/(Om0*h**2))/sqrt(1+10*(Ob0*h**2)**(3./4))
print("H&E: s={}".format(s))


#wiggles
pkwig=pk/pkno

figure()
plot(k,pkwig,'k+',label='SimLSS')
xlabel("k (1/Mpc)")
ylabel("Pk/Pk_nosc")


#position des pics
m=2*arange(1,10)+1
kp=m*pi/(2*s)
[axvline(x=kk,c='k',ls='dashed') for kk in kp]


#fit fonction wiggles
from scipy import optimize
def fitfunc(k,A,ka):
    return 1+A*exp(-(k/0.1)**1.4)*sin(2*pi*k/ka)

k_cut=[0.02,0.20]

p0=[0.1,2*pi/s]
cut=logical_and(k>k_cut[0],k<k_cut[1])

p, pcov=optimize.curve_fit(fitfunc,k[cut],pkwig[cut],p0)

plot(k,fitfunc(k,p[0],p[1]),'k',label="Fit")

xlim((k_cut[0],k_cut[1]))

print("s_rec={}".format(2*pi/p[1]))

#legend()


show()
